# MSA GPU Hello World

Building up on the previous exercise, in this exercise the GPU-side `printf()` function is used to print from a kernel a "hello world!", where the second word is received directly from the CPU process.

TODOs are included in `hello-world.c` and `hello-world.cu`, indicating how to implement the `MPI_Send()` / `MPI_Recv()` structure.

Once the function calls are implemented,e xecute the following on JUWELS Booster

```bash
bash compile.sh
```
(Which is equivalent to calling the `make` for the GPU part of the application, including the right modules.)

Also, execute the following on JUWELS Cluster

```bash
bash compile.sh
sbatch job_msa_juwels.sh
```

(Which compiles the CPU part of the application and then submits a heterogeneous job to the batch queue.)

Monitor your job with `squeue --me`. When it ran through successfully, have a look at the output in `slurm-out.N`, with `N` being your job number.